
#ifndef SCSI_INFO_H_
#define SCSI_INFO_H_

/*
 * Copyright (C) 2004 Red Hat, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * See the file COPYING included with this distribution for more details.
 *
 * $Id: scsi-info.h,v 1.1.2.1 2004/08/10 23:04:49 coughlan Exp $
 *
 * include for info needed by code getting scsi specific info
 *
 */

struct scsi_info {
    struct scsi_info *n;
    char *path;
    int channel;
    int id;
    int lun;
    int host;
    char *page83_type3;  /* Highest priority */
    char *page83_type2;
    char *page83_type1;
    char *page80;
    char *page83_type0;  /* Lowest priority (arbitrary vender assigned id) */
};

/* list handling fxns */
#define list_init(l) { (l)->n = (l); }
#define list_iterate(t, l) for (t = (l)->n; t != (l); t = t->n)
#define list_iterate_safe(t, s, l) for (t = (l)->n, s = t->n; t != (l); t = s, s = t->n)
static inline void list_destroy(struct scsi_info *l) {
    struct scsi_info *n, *tmp;
    list_iterate_safe(n, tmp, l)
        free(n);
    l->n = l;
}

int
get_scsi_info(struct scsi_info *info);

char *
get_devlabel_link(struct scsi_info *info);

#endif /* SCSI_INFO_H_ */
